<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */

require_once('include/MVC/View/views/view.edit.php');
require_once('modules/ky_Tickets/KayakoConnection.php');
class ky_TicketsViewEdit extends ViewEdit
{
	/**
	 * email of requester
	 *
	 * @var string
	 */
	public $requesters;
	/**
	 * referrer module
	 *
	 * @var string
	 */
	public $referrer;

	function ky_TicketsViewEdit()
	{
		parent::ViewEdit();

		$this->referrer = new Lead();
		$this->referrer->retrieve((isset($_REQUEST['record']) ? $_REQUEST['record'] : '' ));
		$this->requester_email = $this->referrer->email1;
		$this->requester_name  = $this->referrer->full_name;
	}

	public function display()
	{
		global $current_user;

		$admin = new Administration();
		$admin->retrieveSettings('kayako');

		if (!isset($admin->settings['system_kayako_url']) || !isset($admin->settings['system_kayako_api']) || !isset($admin->settings['system_kayako_key'])) {
			$link = 'index.php?module=ky_Tickets&action=settingmanager&return_module=' . $_REQUEST['return_module'] . '&return_id=' . $_REQUEST['return_id'] . '&return_action=' . $_REQUEST['return_action'];
			echo "Please <a href='$link'>configure your Kayako Configuaration Settings</a> to edit or create tickets.";
		} else {
			$connection = new KayakoConnection($admin->settings['system_kayako_url'], $admin->settings['system_kayako_api'], $admin->settings['system_kayako_key']);
			if (!isset($_REQUEST['record'])){
				echo "<H2> For All Tickets Please Refer Respective LEAD or CONTACT. </H2>";
				return true;
			}
            global $timedate;
            if (isset($_REQUEST['button']) && !empty($_REQUEST['button'])) {
				$request_array = array(
                    'kemail' => $current_user->email1,
                    'status' => $_REQUEST['status'],
					'priority' => $_REQUEST['priority'],
					'type' => $_REQUEST['type'],
					'department' => $_REQUEST['department'],
					'content' => $_REQUEST['content'],
					'subject' => $_REQUEST['subject'],
					'owner' => $_REQUEST['owner'],
                    'lead_mail' => $_REQUEST['kemail'],);

				$ticket_mask_id = $connection->postTicket($request_array);

                if ($ticket_mask_id === false) {
					echo "Error. Please try Again.";
					header("refresh:5;url=index.php?module=ky_Tickets&action=EditView&return_action=DetailView&record=" . $_REQUEST['record']);
				} else {
					global $db;
					$db->query("INSERT INTO ky_tickets (id, name, date_entered, created_by, assigned_user_id , description, modified_user_id, subject, status, priority, type, department) values ('" . $_REQUEST['record'] . "', '" . $_REQUEST['fullname'] . "', '" . $timedate->nowDbDate() . "', '" . $current_user->email1 . "',  '" . $_REQUEST['owner'] . "', '" . $_REQUEST['content'] . "', '" . $timedate->nowDbDate() . "', '" . $_REQUEST['subject'] . "', '" . $_REQUEST['status'] . "', '" . $_REQUEST['priority'] . "', '" . $_REQUEST['type'] . "' , '" . $_REQUEST['department'] . "');");

					echo "We have received your request and will get back to you with further details shortly. You can login to the support center or check your mailbox for further updates.";
					echo "Your Ticket ID is " . $ticket_mask_id;
					header("refresh:5;url=index.php?action=ajaxui#ajaxUILoc=index.php%3Fmodule%3DLeads%26offset%3D3%26action%3DDetailView%26record%3D" . $_REQUEST['record']);
				}
			} else {
				$connection->fetchAllDepartment();

				$counter = 0;
				foreach ($connection->owner as $_val) {
					$owners[$counter++] = array(
						'id'   => $_val->id,
						'name' => $_val->getFullName()
					);
				}

				$this->ss->assign("email", $this->requester_email);
				$this->ss->assign("departments", $connection->departments);
				$this->ss->assign("priorities", $connection->priority);
				$this->ss->assign("status", $connection->status);
				$this->ss->assign("types", $connection->type);
				$this->ss->assign("owners", $owners);
				$this->ss->assign("full_name", $this->requester_name);
				$this->ss->assign("record", (isset($_REQUEST['record']) ? $_REQUEST['record'] : '' ));
				$this->ss->assign("return_module",(isset($_REQUEST['return_module']) ? $_REQUEST['return_module'] : '' ));
				$this->ss->display('modules/ky_Tickets/tpls/edit.tpl');
			}
		}
	}
}