<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */
if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('include/MVC/View/views/view.list.php');
require_once('modules/ky_Tickets/KayakoConnection.php');

class ViewTickets extends SugarView
{
	/**
	 * email of requester
	 *
	 * @var string
	 */
	public $requesters;
	/**
	 * referrer module
	 *
	 * @var string
	 */
	public $referrer;

	function ViewTickets()
	{
		parent::SugarView();

		switch ($_REQUEST['return_module']) {
			case 'Leads':
				$this->referrer = new Lead();
				$this->referrer->retrieve($_REQUEST['record']);
				$this->requesters = array($this->referrer->email1 => $this->referrer->name);
				break;
			case 'Contacts':
				$this->referrer = new Contact();
				$this->referrer->retrieve($_REQUEST['record']);
				$this->requesters = array($this->referrer->email1 => $this->referrer->name);
				break;
		}
	}

	public function display()
	{
		global $current_user;

		$isAdmin = false;
        $isConverted = false;
		$admin = new Administration();
		$admin->retrieveSettings('kayako');

		if (is_admin($current_user)) {
			$isAdmin = true;
		}

		if (!isset($admin->settings['system_kayako_url']) || !isset($admin->settings['system_kayako_api']) || !isset($admin->settings['system_kayako_key'])) {
			$link = 'index.php?module=ky_Tickets&action=settingmanager&return_module=' . $_REQUEST['return_module'] . '&return_id=' . $_REQUEST['return_id'] . '&return_action=' . $_REQUEST['return_action'];
			echo "Please <a href='$link'>configure your Kayako Configuaration Settings</a> to edit or create tickets.";
		}
		else {
            $ss = new Sugar_Smarty();
			global $db;
			$counter = 0;
			$ticketContainer = array();
            $result = $db->query("SELECT * FROM ky_tickets WHERE id = '" . $_REQUEST['record'] . "'");
			if ($db->getAffectedRowCount($result) != 0) {
				while ($row = $db->fetchByAssoc($result))
				{
					$isConverted = true;
					if ($row['id'] == $_REQUEST['record'])
					{
						$ticketContainer[$counter]['displayid']    = $row['id'];
						$ticketContainer[$counter]['lastactivity'] = $row['modified_user_id'];
						$ticketContainer[$counter]['department']   = $row['department'];
						$ticketContainer[$counter]['type']         = $row['type'];
						$ticketContainer[$counter]['status']       = $row['status'];
						$ticketContainer[$counter]['priority']     = $row['priority'];
						$ticketContainer[$counter]['id']           = $row['id'];
						$ticketContainer[$counter]['view_url']     = $this->parseUrl($admin->settings['system_kayako_url']) . "/Tickets/Ticket/View/" . $row['id'];
						$ticketContainer[$counter++]['subject']    = $row['subject'];


					}
				}
			}
			else {
				$connection        = new KayakoConnection($admin->settings['system_kayako_url'], $admin->settings['system_kayako_api'], $admin->settings['system_kayako_key']);
            	$connection->email = $this->referrer->email1;
				$connection->view();
				$ticketObject = $connection->tickets;

				if (count($ticketObject) > 0) {
					foreach ($ticketObject as $list) {
						$ticketContainer[$counter]['displayid']    = $list->getDisplayId();
						$ticketContainer[$counter]['lastactivity'] = date('M d, Y h:i A', strtotime($list->getLastActivity()));
						$ticketContainer[$counter]['department']   = kyDepartment::get($list->getDepartmentId())->getTitle();
						$ticketContainer[$counter]['type']         = kyTicketType::get($list->getTypeId())->getTitle();
						$ticketContainer[$counter]['status']       = kyTicketStatus::get($list->getStatusId())->getTitle();
						$ticketContainer[$counter]['priority']     = kyTicketPriority::get($list->getPriorityId())->getTitle();
						$ticketContainer[$counter]['id']           = $list->getId();
						$ticketContainer[$counter]['view_url']     = $this->parseUrl($admin->settings['system_kayako_url']) . "/Tickets/Ticket/View/" . $list->getId();
						$ticketContainer[$counter++]['subject']    = $list->getSubject();
					}
				}
			}
				if (count($ticketContainer)) {
				$ss->assign('ticketContainer', $ticketContainer);
			} else {
				$ss->assign('ticketContainer', 'empty');
			}

			$ss->assign('isAdmin', $isAdmin);
			$ss->assign('isConverted', $isConverted);

			$ss->assign('record', (isset($_REQUEST['record']) ? $_REQUEST['record'] : ''));
			$ss->assign('module', (isset($_REQUEST['module']) ? $_REQUEST['module'] : ''));
			$ss->assign('return_module', (isset($_REQUEST['return_module']) ? $_REQUEST['return_module'] : ''));
			$ss->assign('return_action', (isset($_REQUEST['action']) ? $_REQUEST['action'] : ''));


			echo $ss->fetch('modules/ky_Tickets/tpls/tickets.tpl');
           // echo $ss->fetch('modules/Import/tpls/error.tpl');
		}

	}

	private function parseUrl($url)
	{
		$parsedUrl = parse_url($url);

		$parsedUrl['scheme'] .= '://';
		if (stristr($parsedUrl['path'], 'api')) {
			$parsedUrl['path'] = str_replace('/api', '/staff', $parsedUrl['path']);

			return implode($parsedUrl);
		}
		return '';
	}
}



